;      PIC,
; http://pro-radio.ru/controllers/
; 3.
; 4.

    LIST        p=PIC16F628      ;
    #INCLUDE    <P16F628.INC>    ; 
    __CONFIG    3F70h             ; 
;-----------------------------------
;           

jnz		MACRO	metka1		;  ,
		btfss	STATUS,Z	;   0
		goto	metka1
		endm
jz		MACRO	metka2		;  ,
		btfsc	STATUS,Z	;  0
		goto	metka2
		endm
jnc		MACRO	metka3		;  ,
		btfss	STATUS,C	;   
		goto	metka3
		endm
jc		MACRO	metka4		;  ,
		btfsc	STATUS,C	;  
		goto	metka4
		endm
mov		MACRO	DEST1,SOURCE1	;  -
		movf	SOURCE1,W
		movwf	DEST1
		endm
ld		MACRO	DEST2,CONST2	;    
		movlw	CONST2
		movwf	DEST2
		endm
;----------------------------------------------------------
;           (  ""   )
;          (      ""  )
Np      equ    .5                 ;     (10)
                                  ;       
KTMR0   equ    .50                ;   TMR0
Koption equ    B'00000110'        ;  OPTION_REG
                                  ;      .
KNOP7   equ    .10                ;  .
;----------------------------------------------------------
SET1    equ    B'11111111'
;----------------------------------------------------------

;          

        cblock 20h                ;      
        countRA6                  ;    RB6 
        countRA7                  ;    RB7
        REGRA6                    ;    RB6
        REGRA7                    ;    RB7
        TEMP                      ;   
   
        Sec                       ;   
        PauseH                    ;   
        PauseL                    ;   
        PAUSE_H                   ; 
        PAUSE_L                   ;  
        COUNT_KNOP6               ;    6
        COUNT_KNOP7               ;    7
        CYCLE_B                   ; 
        CYCLE_A                   ; 
        CYCLE_C
        OLD_A7                    ;   7
        OLD_A6                    ;   6
        FLAGS                     ;  
        GUDOK1
        GUDOK2
        GPORTA
        endc                      ;   

W_Temp		equ	07Fh              ;  
STAT_Temp	equ	07Eh              ;  W  STATUS
;-----------------------------------
            org    0              ;  
            goto   Main          
;-----------------------------------
            org    4              ;  

;***********************************
;***********************************
;  ,    
;        ( )

Interrupt       
       
        movwf  W_Temp             ;  W  W_Temp
        mov    STAT_Temp,STATUS   ;  STATUS  STAT_Temp

        ld     TMR0,KTMR0         ;  TMR0   

TESTRA6 movlw  b'01000000'        ;  A  W    ,  RA6
        andwf  PORTA,W            ;
        movwf  TEMP               ;    
        XORWF  REGRA6,W           ;  W   REGRA6
        jz     M1               ;  ,   M1 
        decfsz countRA6,F         ;  ,  
        goto   TESTRA7            ;     0
        mov    REGRA6,TEMP        ;  0,     REGRB6
        goto   M1               ;       

TESTRA7 movlw  b'10000000'    
        andwf  PORTA,W       
        movwf  TEMP
        XORWF  REGRA7,W           ;     
        jz     M2
        decfsz countRA7,F
        goto   PER1             
        mov    REGRA7,TEMP
        goto   M2        
;-------------------------------------
M1    ld     countRA6,Np        ;   countRB6   
        goto   TESTRA7            
M2    ld     countRA7,Np        ;   countRB7   
;--------------------------------------
;           A7

PER1    movf   OLD_A7,W           ; 
        XORWF  REGRA7,W           ; 
        andwf  OLD_A7,W           ; 
        movwf  TEMP               ; 
        mov    OLD_A7,REGRA7      ;   
        btfss  TEMP,7             ; 
        goto   PER2               ;    , 

        bsf    FLAGS,0            ;  
        bsf    FLAGS,1
        incf   COUNT_KNOP7,F      ;  
;       movlw  b'00001111'        ;   
;       andwf  COUNT_KNOP7,F      ;   
        movf   COUNT_KNOP7,w	          ; 
        XORlW  KNOP7             ;     
        jnz    PER2               ;  ,
        clrf   COUNT_KNOP7        ;   .
;--------------------------------------
;           A6

PER2    movf   OLD_A6,W           ; 
        XORWF  REGRA6,W           ; 
        andwf  OLD_A6,W           ; 
        movwf  TEMP               ; 
        mov    OLD_A6,REGRA6      ;   
        btfss  TEMP,6             ; 
        goto   TIME               ;    , 
        bsf    FLAGS,1            ;  
        incf   COUNT_KNOP6,F      ;  
        movlw  b'00000011'        ;   
        andwf  COUNT_KNOP6,F      ;   
       
;-------------------------------------
;        

TIME    movf   COUNT_KNOP6,W 
        addwf  PCL, F             ;  4  
        goto   TIME1              ; 
        goto   TIME2              ; 
        goto   TIME3              ; 
        goto   TIME4              ; 
;--------------------------------------                 
TIME1   ld     PAUSE_H,.200       ;      
        ld     PAUSE_L,.169       ;    
        goto   ENDINT
;--------------------------------------                 
TIME2   ld     PAUSE_H,.150       ;      
        ld     PAUSE_L,.169       ;    
        goto   ENDINT
;--------------------------------------                 
TIME3   ld     PAUSE_H,.100       ;      
        ld     PAUSE_L,.169       ;    
        goto   ENDINT
;--------------------------------------                 
TIME4   ld     PAUSE_H,.75        ;      
        ld     PAUSE_L,.169       ;    
;----------------------------------
;       

ENDINT  bcf    INTCON,T0IF        ;      TMR0
        mov    STATUS,STAT_Temp   ; 
        swapf  W_Temp,F           ; W  STATUS
        swapf  W_Temp,W           ;     
        retfie

;**********************************
;**********************************
;                     

Main    clrf   INTCON             ;   
;------------------------------------
        clrf   PORTA              ; 
        movlw  B'00000111'        ; 
        movwf  CMCON              ; 
;------------------------------------
        bsf    STATUS,RP0         ;    .                
        clrf   TRISB              ;    
        movlw  B'11110000'        ;  -  
        movwf  TRISA^80              ;
        ld     OPTION_REG,Koption ;  OPTION_REG
        bcf    STATUS,RP0         ;    .
        ld     TMR0,KTMR0         ;  
        ld     REGRA6,B'01000000' ;  
        ld     REGRA7,B'10000000' ;   .
        ld     OLD_A6,B'01000000' ;  
        ld     OLD_A7,B'10000000' ;   .
        ld     countRA6,Np        ;   countRB6   
        ld     countRA7,Np        ;   countRB7   
        clrf   COUNT_KNOP7        ;    
        clrf   COUNT_KNOP6
        ld     PAUSE_H,.1       ;        ( .200)
        ld     PAUSE_L,.1       ;     ( .169)
        ld     PORTA,SET1         ;    A
        ld     PORTB,SET1         ;    B
                         
;----------------------------------
;       

OPROS   ld     CYCLE_A,SET1
        ld     CYCLE_B,SET1 
        ld     CYCLE_C,SET1
        movf   COUNT_KNOP7,W 
        addwf  PCL, F             ;  10  
        goto   LIGHT1             ; 
        goto   LIGHT2             ; 
        goto   LIGHT3             ; 
        goto   LIGHT4             ;
        goto   LIGHT5             ; 
        goto   LIGHT6             ; 
        goto   LIGHT7             ; 
        goto   LIGHT8             ; 
        goto   LIGHT9             ; 
        goto   LIGHT10            ; 
  
;********************************** 
;        
;  (  )

LIGHT1  bsf    STATUS,C           ;   
;       bcf    CYCLE_B,0
Loop1   mov    PORTB,CYCLE_B	;    
        mov    PORTA,CYCLE_A	;    .
;       rlf    CYCLE_B,F
;       rlf    CYCLE_A,F
        call   Pause              ;    
;       btfsc  CYCLE_A,4
;       goto   Loop1              ; 
        goto   OPROS              ;     
        
;**********************************
;	  
;  (  )
  
LIGHT2  bsf    STATUS,C           ;   
;       bcf    CYCLE_A,3
;Loop2   mov    PORTB,CYCLE_B
;        mov    PORTA,CYCLE_A
;        rrf    CYCLE_A,F
;        rrf    CYCLE_B,F
	  clrf    PORTA		;    
	  clrf    PORTB		;    .
        call   Pause              ;    
;        btfsc  STATUS,C
;        goto   Loop2              ; 
        goto   OPROS              ;     

;**********************************

LIGHT3  bsf    STATUS,C           ;   
        bcf    CYCLE_B,0
Loop31  mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rlf    CYCLE_B,F
        rlf    CYCLE_A,F
        call   Pause              ;    
        btfsc  CYCLE_A,3
        goto   Loop31              ; 
        bcf    CYCLE_A,3
Loop32  mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rrf    CYCLE_A,F
        rrf    CYCLE_B,F
        call   Pause              ;    
        btfsc  CYCLE_B,0
        goto   Loop32              ; 
        goto   OPROS              ;   

;**********************************

LIGHT4  bcf    CYCLE_B,0
Loop41  bcf    STATUS,C
        mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rlf    CYCLE_B,F
        rlf    CYCLE_A,F
        call   Pause         
        btfsc  CYCLE_A,4
        goto   Loop41            

        bsf    CYCLE_B,0
Loop42  bsf    STATUS,C
        mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rlf    CYCLE_B,F
        rlf    CYCLE_A,F
        call   Pause              
        btfss  CYCLE_A,4
        goto   Loop42              
        goto   OPROS

;**********************************

LIGHT5  ld     CYCLE_A,B'00000111'
Loop51  bcf    STATUS,C
        mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rrf    CYCLE_A,F
        rrf    CYCLE_B,F
        call   Pause         
        btfsc  STATUS,C
        goto   Loop51            

        ld     CYCLE_A,B'11111000'
Loop52  bsf    STATUS,C
        mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rrf    CYCLE_A,F
        rrf    CYCLE_B,F
        call   Pause              
        btfss  STATUS,C
        goto   Loop52              
        goto   OPROS

;**********************************

LIGHT6  bcf    CYCLE_B,0
Loop61  bcf    STATUS,C
        mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rlf    CYCLE_B,F
        rlf    CYCLE_A,F
        call   Pause         
        btfsc  CYCLE_A,4
        goto   Loop61            

        bsf    CYCLE_B,0
Loop62  bsf    STATUS,C
        mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rlf    CYCLE_B,F
        rlf    CYCLE_A,F
        call   Pause              
        btfss  CYCLE_A,4
        goto   Loop62              

        ld     CYCLE_A,B'00000111'
Loop63  bcf    STATUS,C
        mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rrf    CYCLE_A,F
        rrf    CYCLE_B,F
        call   Pause         
        btfsc  STATUS,C
        goto   Loop63            

        ld     CYCLE_A,B'11111000'
Loop64  bsf    STATUS,C
        mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rrf    CYCLE_A,F
        rrf    CYCLE_B,F
        call   Pause              
        btfss  STATUS,C
        goto   Loop64              
        goto   OPROS

;**********************************

LIGHT7  ld     CYCLE_A,B'11111110'
        ld     CYCLE_B,B'01111111'     
Loop7   bsf    STATUS,C
        call   SDVIG
        rrf    CYCLE_B,F
        rlf    CYCLE_A,F 
        call   Pause         
        btfsc  CYCLE_A,6
        goto   Loop7            
        goto   OPROS

;**********************************

LIGHT8  ld     CYCLE_A,B'11111110'
        ld     CYCLE_B,B'01111111'     
Loop81  bsf    STATUS,C
        call   SDVIG
        rrf    CYCLE_B,F
        rlf    CYCLE_A,F 
        call   Pause         
        btfsc  CYCLE_A,5
        goto   Loop81            
            
Loop82  call   SDVIG
        rlf    CYCLE_B,F
        rrf    CYCLE_A,F 
        call   Pause         
        btfsc  CYCLE_A,0
        goto   Loop82            
        goto   OPROS

;********************************** 
;       
 
LIGHT9  bsf    STATUS,C           ;   
        bcf    CYCLE_B,0
Loop9   mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rlf    CYCLE_B,F
        rlf    CYCLE_A,F
        call   Pause              ;    
        btfsc  CYCLE_A,4
        goto   Loop9              ; 
        goto   OPROS              ;     
        
;**********************************
  
LIGHT10  bsf    STATUS,C           ;   
        bcf    CYCLE_A,3
Loop10  mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rrf    CYCLE_A,F
        rrf    CYCLE_B,F
        call   Pause              ;    
        btfsc  STATUS,C
        goto   Loop10              ; 
        goto   OPROS              ;     



;**********************************
      ;      

SDVIG   rrf    CYCLE_A,F
        rrf    CYCLE_B,F
        rrf    CYCLE_A,F
        rrf    CYCLE_B,F
        mov    PORTB,CYCLE_B
        mov    PORTA,CYCLE_A
        rlf    CYCLE_B,F
        rlf    CYCLE_A,F
        rlf    CYCLE_B,F
        rlf    CYCLE_A,F
        return

;**********************************

      ;  
   
Pause   ld     INTCON,B'10100000' ;  
       
        mov    PauseH,PAUSE_H     ;     
        mov    PauseL,PAUSE_L     ;     . 
P       nop
        btfsc  FLAGS,1            ;     ?
        goto   GUD                ;

GUD2    decfsz PauseL,F           ;  
        goto   P                  ;   
        decfsz PauseH,F           ;
        goto   P                  ;
        clrf   INTCON             ;   

;----------------------------------
        btfss  FLAGS,0            ;      ?                    
        return                    ;   
        bcf    FLAGS,0
        goto   OPROS


;           



GUD     mov    GPORTA,PORTA
        clrf   INTCON
        bsf    STATUS,RP0         ;    .
        movlw  B'11100000'        ;  -  
        movwf  TRISA          
        bcf    STATUS,RP0         
        
        clrf   GUDOK1
        ld     GUDOK2,.10
H4      btfss  GUDOK1,5
        goto   H1
        goto   H2
H1      bcf    GPORTA,4
        goto   H3
H2      bcf    GPORTA,4          ; bsf.    ,    0.
H3      mov    PORTA,GPORTA
        decfsz GUDOK1,F
        goto   H4
        decfsz GUDOK2,F
        goto   H4

        bsf    STATUS,RP0         ;    .
        movlw  B'11110000'        ;  -  
        movwf  TRISA              ;
        bcf    STATUS,RP0         ;    .
        bcf    FLAGS,1
        ld     INTCON,B'10100000' ;  
        goto   GUD2

;----------------------------------
        end
      

